package edu.cmu.cs211.dynprog.tests;

import static junit.framework.Assert.assertEquals;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.StringTokenizer;

import org.junit.Test;

import edu.cmu.cs211.dynprog.SubsequenceCounter;

public class SubsequenceCounterTest {

	@Test
	public void counterTest() {
		testCountSubsequences("AA", "AAA", 3);
	}

	@Test
	public void getAllSanityTest() {
		testGetAllSubsequences("AA", "AAA", "0,1:0,2:1,2");
	}

	private void testCountSubsequences(String x, String y, int expected) {
		byte[] xarr = x.getBytes();
		byte[] yarr = y.getBytes();
		assertEquals("countSubsequences(" + x + "," + y + ") incorrect", expected,
				SubsequenceCounter.countSubsequences(xarr, yarr));
	}

	/*
	 * The format of the string set is: each list is a comma delimited list of
	 * integers the set is then a colon delimited set of lists so "0,1:0,2:1,2"
	 * translates to: { <0,1>, <0,2>, <1,2> }.
	 */
	private void testGetAllSubsequences(String x, String y, String set) {
		Set<List<Integer>> expected = new HashSet<List<Integer>>();
		byte[] xarr = x.getBytes();
		byte[] yarr = y.getBytes();

		if (set != null) {
			if (set.length() == 0)
				expected.add(new ArrayList<Integer>());
			else {
				StringTokenizer list = new StringTokenizer(set, ":");
				while (list.hasMoreTokens()) {
					List<Integer> l = new ArrayList<Integer>();
					StringTokenizer elements = new StringTokenizer(list.nextToken(), ",");
					while (elements.hasMoreTokens())
						l.add(Integer.parseInt(elements.nextToken()));
					expected.add(l);
				}
			}
		}

		assertEquals("getAllSubsequences(" + x + "," + y + ") incorrect", expected,
				SubsequenceCounter.getAllSubsequences(xarr, yarr));
	}
}
